/* 
 * Admin Menu Script v1.1 22/05/2002. Copyright (C) 2002 OLO.
 */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define BAN_TIME		0

#define NO_MENU		0
#define PLAYER_MENU	1
#define CMD_MENU		2
#define CVAR_MENU		3
#define MAP_MENU		4
#define MAIN_MENU		5

new mKeys[10] = {1,2,4,8,16,32,64,128,256,512};
new UserMenu[MAX_PLAYERS] = { NO_MENU , ... };	/*Menu status - place in menu*/
new UserMenuBits[MAX_PLAYERS] = { 0, ... };	/*Keys - prevent from "menuselect x" usage*/
new UserMenuState[MAX_PLAYERS] = { 0, ... };	/*Keeps current page of menu*/
new UserMenuPlayers[MAX_PLAYERS][MAX_PLAYERS];	/*Table for keeping players indexes*/
new UserMenuCmdPos[MAX_PLAYERS] = { 0 , ... };	/*Keeps active player command*/
new UserMenuID[MAX_PLAYERS] = { 0 , ... };	/*Keeps userid*/

#define MAX_CVAR_NUM 16
new cvar_num = 0;
new CvarsList[MAX_CVAR_NUM][32];
new CvarsListMax[MAX_CVAR_NUM][2];
			
#define MAX_MAP_NUM 16			
new map_num = 0;
new MapsList[MAX_MAP_NUM][32];

#define MAX_CMD_NUM 16	
new cmd_num = 0;
new CmdsList[MAX_CMD_NUM][32];		/*Name of command for menu*/
new CmdsListCmd[MAX_CMD_NUM][64];		/*Command to exec when selected*/

/* Make sure you have file_access_read set to 1 */
public ReadCfg(sFile[])
{
  new iLine = 1;
  new sData[MAX_TEXT_LENGTH];
  new pWord[MAX_NAME_LENGTH];
  new pName[MAX_NAME_LENGTH];
  new pParm1[MAX_NAME_LENGTH];
  new pParm2[MAX_NAME_LENGTH];

  if (fileexists(sFile)) {  
	while (readfile(sFile,sData,iLine++,MAX_TEXT_LENGTH)){
	  pWord[0]=0; /*Clear last word - in case of strgsplit failure*/
	  strgsplit(sData, " ", "^"", pWord, MAX_NAME_LENGTH, pName, MAX_NAME_LENGTH, pParm1, MAX_NAME_LENGTH,pParm2,MAX_NAME_LENGTH);
	  
	  if (map_num < MAX_MAP_NUM && streq(pWord,"menu_map")) {
	  	strcpy(MapsList[map_num++], pName,32);
	  }
	  else if (cvar_num < MAX_CVAR_NUM && streq(pWord,"menu_cvar")) {
	  	strcpy(CvarsList[cvar_num], pName,32);
		CvarsListMax[cvar_num][0] = strtonum(pParm1);	
		CvarsListMax[cvar_num++][1] = strtonum(pParm2);	
	  }
	  else if (cmd_num < MAX_CMD_NUM && streq(pWord,"menu_cmd")) {
		strcpy(CmdsList[cmd_num],pName,32);
		strcpy(CmdsListCmd[cmd_num++],pParm1,64);
	  }
     }
  }
}

/*Used to flag key which can be used by menu - to prevent from direct "menuselect x"*/
public SetKeysBits(UserIndex, bits)
{
	UserMenuBits[UserIndex] = 0;
	new i;
	for (i = 0; i < 10; ++i)
	{
		if ((bits & mKeys[i])!=0)
			UserMenuBits[UserIndex] |= (1<<i+1);
	}
}

/*Call menu when amin_menu command is used*/
public admin_menu(HLCommand,HLData,HLUserName,UserIndex)
{
	new username[MAX_NAME_LENGTH];
	if (playerinfo(UserIndex,username,MAX_NAME_LENGTH,UserMenuID[UserIndex])) /*Get userid*/
		display_menu(UserIndex, MAIN_MENU, 0 );
	
	return PLUGIN_HANDLED;
}

/*Get indexes of players for menu*/
public GetPlayersList(UserIndex)
{
	new maxplayers = maxplayercount();
	new isvalid[MAX_NAME_LENGTH]; /*To check if palyer is in game*/
	new i, j = 0;
	
	for (i = 1; i <=maxplayers ; ++i) 
	{
		if (playerinfo(i,isvalid,MAX_NAME_LENGTH))
		{
			UserMenuPlayers[UserIndex][j] = i;
			++j;
		}
	}
	
	return j; /*return number of players*/
}

/*Main function generating contents of menu to display*/
public display_menu(UserIndex, MenuID, iState)
{
	new MenuHeader[128];
	new MenuText[512];
	new MenuOutput[512];
	new MenuTmp[128];
	new act_keys = 0;
	
	if (MenuID == MAIN_MENU)
	{
		strcpy(MenuHeader,"\\yAdmin Menu\\w\n\n", 128);
		strcpy(MenuText, "1. Players\n2. Commands\n3. Settings\n4. Maps\n\n0. Exit", 512);
		act_keys = 527;
	}
	else if (MenuID == CMD_MENU)
	{
		new list_end = 0;
		new pages_num = 0;
		
		while (pages_num*8 < cmd_num)  /*Count number of pages*/
			++pages_num;
		
		snprintf(MenuHeader, 128, "\\yCommands Menu %d/%d\\w\n\n" ,iState + 1,pages_num);
		
		UserMenuState[UserIndex] = iState;
		new list_begin = UserMenuState[UserIndex] * 8;
		
		if (cmd_num > list_begin + 8)
			list_end = list_begin + 8;
		else
			list_end = cmd_num;
		
		new i; new j=0; /*Here use also j var because you can meke that some options can be disabled*/
		
		for (i = list_begin; i < list_end; ++i)
		{
			snprintf(MenuTmp,128, "\\w%d.  %s\n", j +1 , CmdsList[i]);
			strcat(MenuText, MenuTmp, 512);
			act_keys += mKeys[j];
			++j;
		}
		
		if (list_end < cmd_num) 
		{
			strcat(MenuText,"\n\\w9.  More...",512);
			act_keys += mKeys[8];
		}
		
		strcat(MenuText,"\n\\w0.  Back\n",512);
		act_keys += mKeys[9];
		
	}
	else if (MenuID == MAP_MENU)
	{
		new list_end = 0;
		new pages_num = 0;
		
		while (pages_num*7 < map_num)  /*Count number of pages*/
			++pages_num;
		
		snprintf(MenuHeader, 128, "\\yMaps Menu %d/%d\\w\n\n" ,iState + 1,pages_num);
		
		UserMenuState[UserIndex] = iState;
		new list_begin = UserMenuState[UserIndex] * 7;
		
		if (map_num > list_begin + 7)
			list_end = list_begin + 7;
		else
			list_end = map_num;
		
		new i; new j=0; /*Here use also j var because you can meke that some options can be disabled*/
		
		for (i = list_begin; i < list_end; ++i)
		{
			snprintf(MenuTmp,128, "\\w%d.  %s\n", j +1 , MapsList[i]);
			strcat(MenuText, MenuTmp, 512);
			act_keys += mKeys[j];
			++j;
		}

		if (UserMenuCmdPos[UserIndex] == 0) {
			strcat(MenuText,"\n\\w8.  Changelevel\n",512);
		}
		else if (UserMenuCmdPos[UserIndex] == 1) {
			strcat(MenuText,"\n\\w8.  Quick chlvl\n",512);
		}
		else {
			strcat(MenuText,"\n\\w8.  Vote map\n",512);
		}

		act_keys += mKeys[7];
		
		if (list_end < map_num) 
		{
			strcat(MenuText,"\n\\w9.  More...",512);
			act_keys += mKeys[8];
		}
		
		strcat(MenuText,"\n\\w0.  Back\n",512);
		act_keys += mKeys[9];
		
	}
	else if (MenuID == CVAR_MENU)
	{
		new list_end = 0;
		new pages_num = 0;
		
		while (pages_num*8 < cvar_num)  /*Count number of pages*/
			++pages_num;
		
		snprintf(MenuHeader, 128, "\\ySettings Menu %d/%d\\w\n\n" ,iState + 1,pages_num);
		
		UserMenuState[UserIndex] = iState;
		new list_begin = UserMenuState[UserIndex] * 8;
		
		if (cvar_num > list_begin + 8)
			list_end = list_begin + 8;
		else
			list_end = cvar_num;
		
		new i; new j=0;
		
		for (i = list_begin; i < list_end; ++i)
		{
			snprintf(MenuTmp,128, "\\w%d.  %s %i\n", j+1 , CvarsList[i], getvar(CvarsList[i]));
			strcat(MenuText, MenuTmp, 512);
			act_keys += mKeys[j];
			++j;
		}
		
		if (list_end < cvar_num)
		{
			strcat(MenuText,"\n\\w9.  More...",512);
			act_keys += mKeys[8];
		}
		
		strcat(MenuText,"\n\\w0.  Back\n",512);
		act_keys += mKeys[9];
		
	}
	else if (MenuID == PLAYER_MENU)
	{
		new obj_num = GetPlayersList(UserIndex); /*Build list of players and get players number*/
		new list_end = 0, list_begin = 0;
		new pages_num = 0;

		if (iState * 7 >= obj_num)
		{
			iState = 0; /*if no one is on current page (i.e. after kicking) then reset to 0 state*/
		}

		while (pages_num*7 < obj_num) /*Count number of pages*/
			++pages_num;
		
		snprintf(MenuHeader, 128, "\\yPlayers Menu %d/%d\\w\n\n" ,iState + 1,pages_num);
		
		UserMenuState[UserIndex] = iState;
		list_begin = iState*7;
		
		if (obj_num > list_begin + 7)
			list_end = list_begin + 7;
		else
			list_end = obj_num;
		
		new i; new j=0;
		new pname[MAX_NAME_LENGTH];
		
		for (i = list_begin; i < list_end; ++i)
		{
			playerinfo(UserMenuPlayers[UserIndex][i],pname,MAX_NAME_LENGTH);
			snprintf(MenuTmp,128, "\\w%d.  %s\n", j+1, pname );
			strcat(MenuText, MenuTmp, 512);
			act_keys += mKeys[j];
			++j;
		}
		
		if (UserMenuCmdPos[UserIndex] == 0) {
			strcat(MenuText,"\n\\w8.  Kick player\n",512);
		}
		else if (UserMenuCmdPos[UserIndex] == 1) {
			strcat(MenuText,"\n\\w8.  Ban player\n",512);
		}
		else /*if (UserMenuCmdPos[UserIndex] == 2)*/ {
			strcat(MenuText,"\n\\w8.  Vote kick\n",512);
		}
		/*else {
			strcat(MenuText,"\n\\w8.  Slap player\n",512);
		}*/
		
		act_keys += mKeys[7];
		
		if (list_end < obj_num)
		{
			strcat(MenuText,"\n\\w9.  More...",512);
			act_keys += mKeys[8];
		}
		
		strcat(MenuText,"\n\\w0.  Back\n",512);
		act_keys += mKeys[9];
		
	}
	
	/*Send server command to Metamod plugin to display menu of admin who called this command*/
	snprintf(MenuOutput, 512, "sm_showmenu #%d ^"%s%s^" b%d %d", UserMenuID[UserIndex], MenuHeader, MenuText, act_keys, MenuID);
	exec(MenuOutput);
	UserMenu[UserIndex] = MenuID; /*Set menu id which will be displayed*/
	SetKeysBits(UserIndex,act_keys); /*Set "menuselect x" protection*/
}


/*Timers for admins who calls menus which have to be refreshed with small delay (1 sec. is definitly too long!!!)*/
public delay_menu(Timer, Repeat, HLUser, HLParam)
{ 
	new NewState[8];
	new NewIndex[8];
	new NewType[8];
	new NewParam[8];
	convert_string(HLParam,NewParam,8);
	strsplit(NewParam, " ", NewIndex, 8, NewState, 8, NewType, 8);
	new MenuIndex = strtonum(NewIndex); /* convert string index to number */
	new MenuState = strtonum(NewState);
	new MenuType = strtonum(NewType);
	display_menu(MenuIndex, MenuType, MenuState);
}

/*Menuselect handler - works with menuselect command and calls from keys*/
public menuselect(HLCommand,HLData,HLUserName,UserIndex)
{
	/*If there is any menu running*/
	if (UserMenu[UserIndex] != NO_MENU)
	{	
		new Data[8];					/*Small buffor because there is only one small number*/
		convert_string(HLData,Data,8);
		new iMenu = strtonum(Data);
		new begin_select = 8*UserMenuState[UserIndex]; /*Get internal position in menu*/
		
		if ((UserMenuBits[UserIndex] & (1<<iMenu)) == 0)
			return PLUGIN_HANDLED;
		
		if (UserMenu[UserIndex] == MAIN_MENU)
		{
			if (iMenu == 10) /*exit was choosen*/
			{
				UserMenu[UserIndex] = NO_MENU;
			}
			else
			{
				display_menu(UserIndex, iMenu ,0);
			}

			return PLUGIN_HANDLED;
		}
		else if (UserMenu[UserIndex] == CMD_MENU)
		{
			if (iMenu>0&&iMenu<9)
			{
				begin_select += iMenu-1;
				exec(CmdsListCmd[begin_select]);
				display_menu(UserIndex, CMD_MENU, UserMenuState[UserIndex]);
			}
			else if (iMenu == 9)
			{
				display_menu(UserIndex, CMD_MENU, UserMenuState[UserIndex] + 1);
			}
			else if (iMenu == 10)	
			{
				if (UserMenuState[UserIndex] == 0)
					display_menu(UserIndex, MAIN_MENU ,0);
				else
					display_menu(UserIndex, CMD_MENU, UserMenuState[UserIndex] - 1);
			}
			
			return PLUGIN_HANDLED;
		}
		else if (UserMenu[UserIndex] == CVAR_MENU)
		{
			if (iMenu>0&&iMenu<9)
			{
				begin_select += iMenu-1;
				new chcvar_cmd[16];
				new cvar_v = getvar(CvarsList[begin_select]);
				
				if (cvar_v + CvarsListMax[begin_select][0] > CvarsListMax[begin_select][1])
					cvar_v = 0;
				else 
					cvar_v = cvar_v + CvarsListMax[begin_select][0];
				
				snprintf(chcvar_cmd,16,"%i",cvar_v);
				setstrvar(CvarsList[begin_select], chcvar_cmd);
				UserMenu[UserIndex] = NO_MENU; /*Reset menu status just in case*/
				display_menu(UserIndex, CVAR_MENU, UserMenuState[UserIndex]);
			}
			else if (iMenu == 9)
			{
				display_menu(UserIndex, CVAR_MENU, UserMenuState[UserIndex] + 1);
			}
			else if (iMenu == 10)	
			{
				if (UserMenuState[UserIndex] == 0)
					display_menu(UserIndex, MAIN_MENU ,0);
				else
					display_menu(UserIndex, CVAR_MENU, UserMenuState[UserIndex] - 1);
			}
			
			return PLUGIN_HANDLED;
		}
		else if (UserMenu[UserIndex] == MAP_MENU)
		{
			if (iMenu>0&&iMenu<8)
			{
				begin_select += iMenu-1;
				new chlvl_cmd[128];
				if (UserMenuCmdPos[UserIndex] == 0)
				{
					snprintf(chlvl_cmd,128,"admin_command admin_map %s",MapsList[begin_select]);
				}
				else if (UserMenuCmdPos[UserIndex] == 1)
				{
					snprintf(chlvl_cmd,128,"changelevel %s",MapsList[begin_select]);
				}
				else
				{
					snprintf(chlvl_cmd,128,"admin_command admin_vote_map %s",MapsList[begin_select]);
				}


				exec(chlvl_cmd);
				UserMenu[UserIndex] = NO_MENU; /*Reset menu status coz map is changing or it is time to vote*/
				/*display_menu(UserIndex, MAP_MENU, UserMenuState[UserIndex]); Won't be needed anymore*/

			}
			else if (iMenu == 8)
			{
				UserMenuCmdPos[UserIndex] = UserMenuCmdPos[UserIndex] + 1;
				
				if (UserMenuCmdPos[UserIndex] > 2) /*Remember to incrase this option if chaning commands*/
					UserMenuCmdPos[UserIndex] = 0;

				display_menu(UserIndex, MAP_MENU, UserMenuState[UserIndex]);
			}
			else if (iMenu == 9)
			{
				display_menu(UserIndex, MAP_MENU, UserMenuState[UserIndex] + 1);
			}
			else if (iMenu == 10)	
			{
				if (UserMenuState[UserIndex] == 0)
					display_menu(UserIndex, MAIN_MENU ,0);
				else
					display_menu(UserIndex, MAP_MENU, UserMenuState[UserIndex] - 1);
			}
			
			return PLUGIN_HANDLED;
		}
		else if (UserMenu[UserIndex] == PLAYER_MENU)
		{
			
			if (iMenu>0&&iMenu<8)
			{
				begin_select += iMenu-1;
				new pname[MAX_NAME_LENGTH];
				new	WONID;
				new UserID;
				new cmd_toexec[128];				

				if (playerinfo(UserMenuPlayers[UserIndex][begin_select],pname,MAX_NAME_LENGTH,UserID,WONID))
				{
					UserMenu[UserIndex] = NO_MENU; /*Reset menu status just in case*/
					new NewIndex[10];
					snprintf(NewIndex,10,"%i %i %i",UserIndex,UserMenuState[UserIndex],PLAYER_MENU);

					if (UserMenuCmdPos[UserIndex] == 0)
					{
						snprintf(cmd_toexec,128,"admin_command admin_kick %i",UserID);
						exec(cmd_toexec);
						set_timer("delay_menu", 1 , 0,NewIndex); /*Unfortunetly we must give a delay coz operation on clients are not instant*/
					}
					else if (UserMenuCmdPos[UserIndex] == 1)
					{
						snprintf(cmd_toexec,128,"admin_command admin_ban %i %i",WONID, BAN_TIME);
						exec(cmd_toexec);				
						set_timer("delay_menu", 1 , 0,NewIndex); /*Unfortunetly we must give a delay coz operation on clients are not instant*/

					}
					else /*if (UserMenuCmdPos[UserIndex] == 2)*/
					{
						snprintf(cmd_toexec,128,"admin_command admin_vote_kick %i",UserID);
						exec(cmd_toexec);
					}
					/*else
					{
						slap(pname);
					}
					*/
				}
				
				/*display_menu(UserIndex, PLAYER_MENU, UserMenuState[UserIndex]);*/	
				
			}
			else if (iMenu == 8)
			{
				UserMenuCmdPos[UserIndex] = UserMenuCmdPos[UserIndex] + 1;
				
				if (UserMenuCmdPos[UserIndex] > 2) /*Remember to incrase this option if chaning commands*/
					UserMenuCmdPos[UserIndex] = 0;
				
				display_menu(UserIndex, PLAYER_MENU, UserMenuState[UserIndex]);
			}
			else if (iMenu == 9)
			{
				display_menu(UserIndex, PLAYER_MENU, UserMenuState[UserIndex] + 1);
			}
			else if (iMenu == 10)	
			{
				if (UserMenuState[UserIndex] == 0)
					display_menu(UserIndex, MAIN_MENU ,0);
				else
					display_menu(UserIndex, PLAYER_MENU, UserMenuState[UserIndex] - 1);
			}
			
			return PLUGIN_HANDLED;
		}
	}
	
	return PLUGIN_CONTINUE;
}

/*CS Commands like "buy" or "radio1" display new menu so reset state in this plugin*/
public reset_state(HLCommand,HLData,HLUserName,UserIndex){
	UserMenu[UserIndex] = NO_MENU;
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	UserMenu[UserIndex] = NO_MENU; /*Reset menu state*/
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	UserMenu[UserIndex] = NO_MENU;  /*Reset menu state*/
	return PLUGIN_CONTINUE;
}

public plugin_init(){
	plugin_registerinfo("AdminMenu Plugin","AdminMenu Plugin.","1.0");
	plugin_registercmd("admin_menu","admin_menu",ACCESS_CONFIG,"admin_menu: Displays AdminMenu.");
	plugin_registercmd("menuselect","menuselect",ACCESS_CONFIG);
	plugin_registercmd("radio1","reset_state",ACCESS_ALL);
	plugin_registercmd("radio2","reset_state",ACCESS_ALL);
	plugin_registercmd("radio3","reset_state",ACCESS_ALL);
	plugin_registercmd("buy","reset_state",ACCESS_ALL);
	plugin_registercmd("buyequip","reset_state",ACCESS_ALL);
	plugin_registercmd("chooseteam","reset_state",ACCESS_ALL);
	ReadCfg("menu.ini");
	return PLUGIN_CONTINUE;
}
